def neuralNetwork():
	import numpy as np

	class NeuralNetwork():
		def __init__(self):
			np.random.seed(1)

			self.synaptic_weights = 2 * np.random.random((3, 1)) - 1

		def sigmoid(self, x):
			return 1 / (1 + np.exp(-x))

		def sigmoid_derivative(self, x):
			return x * (1 - x)

		def train(self, training_inputs, training_outputs, training_iterations):
			for iteration in range(training_iterations):
				output = self.think(training_inputs)
				error = training_outputs - output
				adjustments = np.dot(training_inputs.T, error * self.sigmoid_derivative(output))
				self.synaptic_weights += adjustments

		def think(self, inputs):
			inputs = inputs.astype(float)
			output = self.sigmoid(np.dot(inputs, self.synaptic_weights))

			return output

	if __name__ == '__main__':
		neural_network = NeuralNetwork()

		print ("Random synaptic weights: ")
		print (neural_network.synaptic_weights)

		training_inputs = np.array([[0,0,1],
								[1,1,1],
								[1,0,1],
								[0,1,1]])

		training_outputs = np.array([[0,1,1,0]]).T

		neural_network.train(training_inputs, training_outputs, 10000)

		print ("Synaptic weights after training: ")
		print ("neural_network.synaptic_weights")

		in1 = str(input("Input 1: "))
		in2 = str(input("Input 2: "))
		in3 = str(input("Input 2: "))

		print ("New situation: input data = ", in1, in2, in3)
		print ("Output data: ")
		print (neural_network.think(np.array([in1, in2, in3])))
def perceptron():
	import numpy as np 

	def sigmoid(x):
		return 1 / (1 + np.exp(-x))

	def sigmoid_derivative(x):
		return x * (1 - x)

	training_inputs = np.array([[0,0,1],
								[1,1,1],
								[1,0,1],
								[0,1,1]])

	training_outputs = np.array([[0,1,1,0]]).T

	np.random.seed(1)

	synaptic_weights = 2 * np.random.random((3, 1)) - 1

	print ("Random starting synaptic weights: ")
	print (synaptic_weights)

	for iteration in range(100000):
		input_layer = training_inputs

		outputs = sigmoid(np.dot(input_layer, synaptic_weights))

		error = training_outputs - outputs

		adjustments = error * sigmoid_derivative(outputs)

		synaptic_weights += np.dot(input_layer.T, adjustments)

	print ("Synaptic weights after training: ")
	print (synaptic_weights)

	print ("Actual synaptic weights: ")
	print (training_inputs)

	print ("Outputs after training: ")
	print (outputs)

	print ("Correct outputs: ")
	print (training_outputs)